<template>
  <div class="navigation_section">
    <div @click="changeChildren()" class="navigation_section_header" style="white-space: nowrap;">
      <span class="navigation_section_icon" style="vertical-align: middle;">
        <i v-if="!childrenVisible" class="pi pi-angle-right"></i>
        <i v-else class="pi pi-angle-down"></i>
      </span>
      <span style="vertical-align: middle;">{{ title }}</span>
    </div>
    <div v-if="childrenVisible" style="white-space: nowrap;">
      <div v-for="child of children" :key="child">
        <router-link v-if="authorized(child)" :to="child.url" v-slot="slot" custom>
          <div :class="[$route.path === child.url ? 'navigation_item_selected' : '', 'navigation_item']">
            <a :href="slot.href" @click="slot.navigate">{{ child.title }}</a>
          </div>
      </router-link>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";

import type { ChildRouteType } from "@/types";

export default defineComponent({
  props: {
    title: {
      type: String,
      required: true
    },
    baseUrl: {
      type: String,
      required: true
    },
    children: {
      type: Object as PropType<ChildRouteType[]>,
      required: true
    }
  },

  data() {
    return {
      childrenVisible: false
    };
  },

  mounted() {
    if (window.location.pathname.includes(this.baseUrl)) {
      this.childrenVisible = true;
    }
  },

  methods: {
    changeChildren() {
      this.childrenVisible = !this.childrenVisible;
    },

    authorized(): boolean {
      return true;
    }
  }
});
</script>

<style scoped>
.navigation_section
{
  color: #000000;
  text-align: left;
  font-size: 14px;
  line-height: 18px;
}

.navigation_section_header {
  font-weight: bold;
  line-height: 24px;
  padding-left: 20px;
  cursor: pointer;
}

.navigation_section_icon
{
  margin-right: 6px;
}

.navigation_item {
  font-size: 14px;
  line-height: 24px;
  padding-left: 40px;
  cursor: pointer;
}

.navigation_item a {
  text-decoration: none;
  color: #000000;
}

.navigation_item_selected {
  background-color: #b5e0ff;
}
</style>